## jblas 0.1

=== Makefile ===
## --- BEGIN LICENSE BLOCK ---
# Copyright (c) 2009, Mikio L. Braun
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
# 
#     * Neither the name of the Technische Universität Berlin nor the
#       names of its contributors may be used to endorse or promote
#       products derived from this software without specific prior
#       written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
## --- END LICENSE BLOCK ---

# Load the output of the configuration files
ifneq ($(wildcard configure.out),)
include configure.out
else
$(error Please run "./configure" first...)
endif

ifneq ($(LAPACK_HOME),)
LAPACK=$(LAPACK_HOME)/SRC
BLAS=$(LAPACK_HOME)/BLAS/SRC
endif

PACKAGE=org.jblas.la

# generate path from package name
PACKAGE_PATH=$(subst .,/,$(PACKAGE))

#
# Pattern rules
#
# The crazy thing is, with these rules, you ONLY need to specify which
# object files belong to a source file the rest is determined
# automatically by make.
#

# rule to compile files
%.o : %.c
	$(CC) $(CFLAGS) $(INCDIRS) -c $< -o $@

# rule to generate shared library from object file 
%.$(SO) : %.o
	$(LD) $(LDFLAGS) -o $@ $^ $(LOADLIBES)

# the default target
all	: compile-native

compile-native : bin/$(LIB)jblas.$(SO)

generate-wrapper: src/$(PACKAGE_PATH)/Blas.java native/Blas.c

clean:
	rm -f native/*.o native/*.$(SO) bin/*.$(SO) src/$(PACKAGE_PATH)/Blas.java

ifeq ($(LAPACK_HOME),)
realclean:
	@echo "Since you don't have LAPACK sources, I cannot rebuild stubs and deleting the cached information is not a good idea."
	@echo "(nothing deleted)"
else
realclean:
	rm -f fortranwrapper.dump
endif

# Generating the stubs. This target requires that the blas sources can be found in ~/src/blas/*.f
src/$(PACKAGE_PATH)/Blas.java native/Blas.c: scripts/fortranwrapper.rb scripts/fortran.rb scripts/fortran/java.rb scripts/java-class.java scripts/java-impl.c
	$(RUBY) scripts/fortranwrapper.rb $(PACKAGE) Blas \
	$(BLAS)/*.f \
	$(LAPACK)/[sd]gesv.f \
	$(LAPACK)/[sd]sysv.f \
	$(LAPACK)/[sd]syev.f \
	$(LAPACK)/[sd]syev[rdx].f \
	$(LAPACK)/[sd]posv.f \
	$(LAPACK)/[sd]geev.f

bin/$(LIB)jblas.$(SO) : native/Blas.$(SO)
	mv $< $@

#
# For testing
#
VERSION=0.1

make test-dist:
	ant clean tar
	rm -rf jblas-$(VERSION)
	tar xzvf jblas-$(VERSION).tgz
	cd jblas-$(VERSION)
	./configure
	ant clean jar
	cd ..

## jblas 0.3

=== Makefile ===
--- 
+++ 
@@ -44,10 +44,12 @@
 BLAS=$(LAPACK_HOME)/BLAS/SRC
 endif
 
-PACKAGE=org.jblas.la
+PACKAGE=org.jblas
 
 # generate path from package name
 PACKAGE_PATH=$(subst .,/,$(PACKAGE))
+
+LIB_PATH=native-libs/$(LINKAGE)/$(OS_NAME)/$(OS_ARCH)
 
 #
 # Pattern rules
@@ -68,12 +70,12 @@
 # the default target
 all	: compile-native
 
-compile-native : bin/$(LIB)jblas.$(SO)
+compile-native : $(LIB_PATH)/$(LIB)jblas.$(SO)
 
-generate-wrapper: src/$(PACKAGE_PATH)/Blas.java native/Blas.c
+generate-wrapper: src/$(PACKAGE_PATH)/NativeBlas.java native/NativeBlas.c
 
 clean:
-	rm -f native/*.o native/*.$(SO) bin/*.$(SO) src/$(PACKAGE_PATH)/Blas.java
+	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) src/$(PACKAGE_PATH)/NativeBlas.java
 
 ifeq ($(LAPACK_HOME),)
 realclean:
@@ -85,23 +87,26 @@
 endif
 
 # Generating the stubs. This target requires that the blas sources can be found in ~/src/blas/*.f
-src/$(PACKAGE_PATH)/Blas.java native/Blas.c: scripts/fortranwrapper.rb scripts/fortran.rb scripts/fortran/java.rb scripts/java-class.java scripts/java-impl.c
-	$(RUBY) scripts/fortranwrapper.rb $(PACKAGE) Blas \
+src/$(PACKAGE_PATH)/NativeBlas.java native/NativeBlas.c: scripts/fortranwrapper.rb scripts/fortran/types.rb scripts/fortran/java.rb scripts/java-class.java scripts/java-impl.c
+	$(RUBY) scripts/fortranwrapper.rb $(PACKAGE) NativeBlas \
 	$(BLAS)/*.f \
 	$(LAPACK)/[sd]gesv.f \
 	$(LAPACK)/[sd]sysv.f \
 	$(LAPACK)/[sd]syev.f \
 	$(LAPACK)/[sd]syev[rdx].f \
 	$(LAPACK)/[sd]posv.f \
-	$(LAPACK)/[sd]geev.f
+	$(LAPACK)/[sdcz]geev.f \
+	$(LAPACK)/[sd]getrf.f \
+    $(LAPACK)/[sd]potrf.f 
 
-bin/$(LIB)jblas.$(SO) : native/Blas.$(SO)
+$(LIB_PATH)/$(LIB)jblas.$(SO) : native/NativeBlas.$(SO)
+	mkdir -p $(LIB_PATH)
 	mv $< $@
 
 #
 # For testing
 #
-VERSION=0.1
+VERSION=0.3
 
 make test-dist:
 	ant clean tar
@@ -110,4 +115,26 @@
 	cd jblas-$(VERSION)
 	./configure
 	ant clean jar
+	java -cp jblas-$(VERSION).jar org.jblas.util.SanityChecks
 	cd ..
+
+#
+# Building different kinds of jar files
+#
+all-jars:
+	ant clean-jars
+	./configure --keep-options $$(cat configure.options)
+	ant jar 
+	ant lean-jar
+	./configure --keep-options --static-libs $$(cat configure.options)
+	ant compile-native static-jar fat-jar
+
+all-static-jars:
+	./configure --keep-options --static-libs $$(cat configure.options)
+	ant compile-native
+	for os_name in native-libs/*; do \
+	  for os_arch in $$os_name/* ; do \
+	    ant static-jar -Dos_name=$$(basename $$os_name) \
+		-Dos_arch=$$(basename $$os_arch); \
+	  done; \
+	done

## jblas 1.0.2

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,12 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ## --- END LICENSE BLOCK ---
 
+VERSION=1.0.2
+
+######################################################################
+#
 # Load the output of the configuration files
+#
 ifneq ($(wildcard configure.out),)
 include configure.out
 else
@@ -49,9 +54,14 @@
 # generate path from package name
 PACKAGE_PATH=$(subst .,/,$(PACKAGE))
 
-LIB_PATH=native-libs/$(LINKAGE)/$(OS_NAME)/$(OS_ARCH)
+LIB_PATH=native-libs/$(LINKAGE_TYPE)/$(OS_NAME)/$(OS_ARCH)
+FULL_LIB_PATH=native-libs/$(LINKAGE_TYPE)/$(OS_NAME)/$(OS_ARCH_WITH_FLAVOR)
 
-#
+GENERATED_SOURCES=src/$(PACKAGE_PATH)/NativeBlas.java native/NativeBlas.c
+GENERATED_HEADERS=include/org_jblas_NativeBlas.h include/org_jblas_util_ArchFlavor.h
+SHARED_LIBS=$(FULL_LIB_PATH)/$(LIB)jblas.$(SO) $(LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO) 
+
+#######################################################################
 # Pattern rules
 #
 # The crazy thing is, with these rules, you ONLY need to specify which
@@ -67,16 +77,25 @@
 %.$(SO) : %.o
 	$(LD) $(LDFLAGS) -o $@ $^ $(LOADLIBES)
 
-# the default target
-all	: compile-native
+######################################################################
+#
+# Main section
+#
 
-compile-native : $(LIB_PATH)/$(LIB)jblas.$(SO)
+# The default target
+all	:  $(SHARED_LIBS)
 
-generate-wrapper: src/$(PACKAGE_PATH)/NativeBlas.java native/NativeBlas.c
+# Generate the code for the wrapper (both Java and C)
+generate-wrapper: $(GENERATED_SOURCES) $(GENERATED_HEADERS)
 
+
+# Clean all object files
 clean:
-	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) src/$(PACKAGE_PATH)/NativeBlas.java
+	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) $(FULL_LIB_PATH)/*.$(SO) src/$(PACKAGE_PATH)/NativeBlas.java
 
+# Full clean, including information extracted from the fortranwrappers.
+# You will need the original fortran sources in order to rebuild
+# the wrappers.
 ifeq ($(LAPACK_HOME),)
 realclean:
 	@echo "Since you don't have LAPACK sources, I cannot rebuild stubs and deleting the cached information is not a good idea."
@@ -86,8 +105,12 @@
 	rm -f fortranwrapper.dump
 endif
 
-# Generating the stubs. This target requires that the blas sources can be found in ~/src/blas/*.f
-src/$(PACKAGE_PATH)/NativeBlas.java native/NativeBlas.c: scripts/fortranwrapper.rb scripts/fortran/types.rb scripts/fortran/java.rb scripts/java-class.java scripts/java-impl.c
+# Generating the stubs. This target requires that the blas sources can
+# be found in the $(BLAS) and $(LAPACK) directories.
+generated-sources: \
+  scripts/fortranwrapper.rb scripts/fortran/types.rb \
+  scripts/fortran/java.rb scripts/java-class.java scripts/java-impl.c \
+  src/org/jblas/util/ArchFlavor.java src/org/jblas/NativeBlas.java 
 	$(RUBY) scripts/fortranwrapper.rb $(PACKAGE) NativeBlas \
 	$(BLAS)/*.f \
 	$(LAPACK)/[sd]gesv.f \
@@ -97,41 +120,69 @@
 	$(LAPACK)/[sd]posv.f \
 	$(LAPACK)/[sdcz]geev.f \
 	$(LAPACK)/[sd]getrf.f \
-    $(LAPACK)/[sd]potrf.f 
+	$(LAPACK)/[sd]potrf.f 
+	ant javah
+	touch $@
 
-$(LIB_PATH)/$(LIB)jblas.$(SO) : native/NativeBlas.$(SO)
+native/NativeBlas.o: generated-sources
+	$(CC) $(CFLAGS) $(INCDIRS) -c native/NativeBlas.c -o $@
+
+native/jblas_arch_flavor.o: generated-sources
+	$(CC) $(CFLAGS) $(INCDIRS) -c native/jblas_arch_flavor.c -o $@
+
+# Move the compile library to the machine specific directory.
+$(FULL_LIB_PATH)/$(LIB)jblas.$(SO) : native/NativeBlas.$(SO)
+	mkdir -p $(FULL_LIB_PATH)
+	mv "$<" "$@"
+
+$(LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO): native/jblas_arch_flavor.$(SO)
 	mkdir -p $(LIB_PATH)
-	mv $< $@
+	mv "$<" "$@"
 
+######################################################################
 #
-# For testing
+# Testing etc.
 #
-VERSION=0.3
 
-make test-dist:
+# run org.jblas.util.SanityChecks
+sanity-checks:
+	java -cp jblas-$(VERSION).jar org.jblas.util.SanityChecks
+
+# Create a tar, extract in a directory, and rebuild from scratch.
+test-dist:
+	make clean all
 	ant clean tar
 	rm -rf jblas-$(VERSION)
 	tar xzvf jblas-$(VERSION).tgz
-	cd jblas-$(VERSION)
-	./configure
-	ant clean jar
-	java -cp jblas-$(VERSION).jar org.jblas.util.SanityChecks
-	cd ..
+	(cd jblas-$(VERSION); ./configure; make -j3; ant jar; LD_LIBRARY_PATH=$(FULL_LIB_PATH):$(LIB_PATH) java -cp jblas-$(VERSION).jar org.jblas.util.SanityChecks)
 
+######################################################################
 #
-# Building different kinds of jar files
+# Packaging
 #
+
+
+# Build different kind of jars:
+#
+# * with dynamic libraries
+# * with static libraries
+# * a "fat" jar with everything
+#
+# FIXME: I think this build target assumes that the current configuration
+# is "dynamic"
 all-jars:
 	ant clean-jars
 	./configure --keep-options $$(cat configure.options)
 	ant jar 
 	ant lean-jar
 	./configure --keep-options --static-libs $$(cat configure.options)
-	ant compile-native static-jar fat-jar
+	make
+	ant static-jar fat-jar
 
+# Build static jars
 all-static-jars:
 	./configure --keep-options --static-libs $$(cat configure.options)
-	ant compile-native
+	make
 	for os_name in native-libs/*; do \
 	  for os_arch in $$os_name/* ; do \
 	    ant static-jar -Dos_name=$$(basename $$os_name) \

## jblas 1.1.1

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ## --- END LICENSE BLOCK ---
 
-VERSION=1.0.2
+VERSION=1.1.1
 
 ######################################################################
 #
@@ -91,17 +91,17 @@
 
 # Clean all object files
 clean:
-	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) $(FULL_LIB_PATH)/*.$(SO) src/$(PACKAGE_PATH)/NativeBlas.java
+	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) $(FULL_LIB_PATH)/*.$(SO) src/$(PACKAGE_PATH)/NativeBlas.java generated-sources
 
 # Full clean, including information extracted from the fortranwrappers.
 # You will need the original fortran sources in order to rebuild
 # the wrappers.
 ifeq ($(LAPACK_HOME),)
-realclean:
+realclean: clean
 	@echo "Since you don't have LAPACK sources, I cannot rebuild stubs and deleting the cached information is not a good idea."
 	@echo "(nothing deleted)"
 else
-realclean:
+realclean: clean
 	rm -f fortranwrapper.dump
 endif
 
@@ -110,9 +110,20 @@
 generated-sources: \
   scripts/fortranwrapper.rb scripts/fortran/types.rb \
   scripts/fortran/java.rb scripts/java-class.java scripts/java-impl.c \
-  src/org/jblas/util/ArchFlavor.java src/org/jblas/NativeBlas.java 
-	$(RUBY) scripts/fortranwrapper.rb $(PACKAGE) NativeBlas \
-	$(BLAS)/*.f \
+  src/org/jblas/util/ArchFlavor.java #src/org/jblas/NativeBlas.java 
+	$(RUBY) scripts/fortranwrapper.rb --complexcc $(CCC) $(PACKAGE) NativeBlas \
+	$(BLAS)/[sdcz]copy.f \
+	$(BLAS)/[sdcz]swap.f \
+	$(BLAS)/[sdcz]axpy.f \
+	$(BLAS)/[sdcz]scal.f \
+  $(BLAS)/[cz][sd]scal.f \
+	$(BLAS)/[sdcz]dot*.f \
+	$(BLAS)/[sd]*nrm2.f \
+	$(BLAS)/[sd]*asum.f \
+	$(BLAS)/i[sdcz]amax.f \
+	$(BLAS)/[sdcz]gemv.f \
+	$(BLAS)/[sdcz]ger*.f \
+	$(BLAS)/[sdcz]gemm.f \
 	$(LAPACK)/[sd]gesv.f \
 	$(LAPACK)/[sd]sysv.f \
 	$(LAPACK)/[sd]syev.f \
@@ -120,11 +131,14 @@
 	$(LAPACK)/[sd]posv.f \
 	$(LAPACK)/[sdcz]geev.f \
 	$(LAPACK)/[sd]getrf.f \
-	$(LAPACK)/[sd]potrf.f 
+	$(LAPACK)/[sd]potrf.f \
+	$(LAPACK)/[sdcz]gesvd.f
 	ant javah
 	touch $@
 
-native/NativeBlas.o: generated-sources
+native/NativeBlas.c: generated-sources
+
+native/NativeBlas.o: native/NativeBlas.c
 	$(CC) $(CFLAGS) $(INCDIRS) -c native/NativeBlas.c -o $@
 
 native/jblas_arch_flavor.o: generated-sources

=== debian/changelog ===
jblas (1.1.1-2) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.
  * Add patch from upstream fixing a number of complex matrix related
  functions.

 -- Soeren Sonnenburg <sonne@debian.org>  Tue, 19 Oct 2010 12:11:02 +0200

jblas (1.1.1-1) unstable; urgency=low

  * New upstream bugfix release.

 -- Soeren Sonnenburg <sonne@debian.org>  Thu, 09 Sep 2010 18:50:12 +0200

jblas (1.1-1) unstable; urgency=low

  * New upstream version (Closes: #593352)
  * Update Standards-Version: 3.9.1.0 (no changes).

 -- Soeren Sonnenburg <sonne@debian.org>  Wed, 18 Aug 2010 11:28:56 +0200

jblas (1.0.2-1) unstable; urgency=low

  * New upstream version (Closes: Bug#570652)
  * Fix installation on archs other than x86{,_64}.

 -- Soeren Sonnenburg <sonne@debian.org>  Thu, 25 Feb 2010 14:37:52 +0100

jblas (1.0.1-1) unstable; urgency=low

  * New upstream version.
  * Update Standards-Version: 3.8.4 (no changes).

 -- Soeren Sonnenburg <sonne@debian.org>  Thu, 11 Feb 2010 14:49:56 +0100

jblas (0.3-1) unstable; urgency=low

  [ Torsten Werner ]
  * Fix Vcs headers.

  [ Soeren Sonnenburg ]
  * New upstream version.
  * Update Standards-Version: 3.8.3 (no changes).
  * Upstream moved to github, change homepage, watchfile etc accordingly.

 -- Soeren Sonnenburg <sonne@debian.org>  Thu, 17 Sep 2009 17:30:53 +0200

jblas (0.1-2) unstable; urgency=low

  * Change Maintainer: Debian Java Maintainers.
  * Add myself to Uploaders.
  * Update Standards-Version: 3.8.2 (no changes).

 -- Torsten Werner <twerner@debian.org>  Mon, 29 Jun 2009 20:44:15 +0200

jblas (0.1-1) unstable; urgency=low

  * Initial Release (Closes: #522017)

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 10 Apr 2009 11:39:57 +0200

=== debian/control ===
Source: jblas
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Soeren Sonnenburg <sonne@debian.org>,
 Torsten Werner <twerner@debian.org>
Build-Depends: cdbs, debhelper (>= 7), openjdk-6-jdk, ant-optional, gfortran,
 libatlas-base-dev, ruby
Standards-Version: 3.9.1.0
Section: science
Homepage: http://jblas.org
Vcs-Svn: svn+ssh://svn.debian.org/svn/pkg-java/trunk/jblas
Vcs-Browser: http://svn.debian.org/wsvn/pkg-java/trunk/jblas/

Package: jblas
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openjdk-6-jre | sun-java6-jre,
Description: A fast linear algebra library for Java
 jblas is a fast linear algebra library for Java. jblas is essentially
 a light-weight wrapper around BLAS and LAPACK routines, the
 de-facto industry standard for matrix computations. It uses
 state-of-the-art implementations like ATLAS for all its computational
 routines, making it very fast. 
 .
 This package contains the binaries and examples.

Package: jblas-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: jblas
Section: doc
Description: A fast linear algebra library for Java
 jblas is a fast linear algebra library for Java. jblas is essentially
 a light-weight wrapper around BLAS and LAPACK routines, the
 de-facto industry standard for matrix computations. It uses
 state-of-the-art implementations like ATLAS for all its computational
 routines, making it very fast. 
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/ant.mk

JAVA_HOME_DIRS       := /usr/lib/jvm/java-6-openjdk
DEB_ANT_BUILDFILE    := build.xml
DEB_ANT_BUILD_TARGET := minimal-jar javadoc
DEB_ANT_CLEAN_TARGET := clean clean-jars
DEB_JARS := ant-nodeps.jar

clean::
	make clean || true

debian/stamp-ant-build: debian/stamp-jblas-build
debian/stamp-jblas-build:
	./configure --libpath=/usr/lib:/usr/lib/atlas
	make
	touch $@

install/jblas::
	install -m755 -d debian/jblas/usr/lib/jni
	install -m644 $(shell find ./native-libs/dynamic/Linux/ -name '*.so') debian/jblas/usr/lib/jni
	install -m644 -D jblas-minimal-$(DEB_UPSTREAM_VERSION).jar debian/jblas/usr/share/java/jblas-$(DEB_UPSTREAM_VERSION).jar
	dh_link -pjblas /usr/share/java/jblas-$(DEB_UPSTREAM_VERSION).jar /usr/share/java/jblas.jar

install/jblas-doc:: debian/stamp-install-jblas-doc
debian/stamp-install-jblas-doc:
	#install javadoc javadoc
	install -m755 -d debian/jblas-doc/usr/share/doc/jblas-doc
	cp -r javadoc debian/jblas-doc/usr/share/doc/jblas-doc/
	touch $@

get-orig-source:
	-uscan --rename --upstream-version 0
	@echo successfully retrieved upstream tarball

## jblas 1.2.0

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ## --- END LICENSE BLOCK ---
 
-VERSION=1.1.1
+VERSION=1.2.0
 
 ######################################################################
 #
@@ -54,11 +54,18 @@
 # generate path from package name
 PACKAGE_PATH=$(subst .,/,$(PACKAGE))
 
-LIB_PATH=native-libs/$(LINKAGE_TYPE)/$(OS_NAME)/$(OS_ARCH)
-FULL_LIB_PATH=native-libs/$(LINKAGE_TYPE)/$(OS_NAME)/$(OS_ARCH_WITH_FLAVOR)
-
-GENERATED_SOURCES=src/$(PACKAGE_PATH)/NativeBlas.java native/NativeBlas.c
-GENERATED_HEADERS=include/org_jblas_NativeBlas.h include/org_jblas_util_ArchFlavor.h
+SRC=src/main
+SRC_JAVA=$(SRC)/java
+SRC_C=$(SRC)/c
+RESOURCES=$(SRC)/resources
+
+TARGET_C=target/c
+
+LIB_PATH=$(RESOURCES)/lib/$(LINKAGE_TYPE)/$(OS_NAME)/$(OS_ARCH)
+FULL_LIB_PATH=$(RESOURCES)/lib/$(LINKAGE_TYPE)/$(OS_NAME)/$(OS_ARCH_WITH_FLAVOR)
+
+GENERATED_SOURCES=$(SRC_JAVA)/$(PACKAGE_PATH)/NativeBlas.java $(SRC_C)/NativeBlas.c
+GENERATED_HEADERS=$(SRC_C)/org_jblas_NativeBlas.h $(SRC_C)/org_jblas_util_ArchFlavor.h
 SHARED_LIBS=$(FULL_LIB_PATH)/$(LIB)jblas.$(SO) $(LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO) 
 
 #######################################################################
@@ -91,7 +98,7 @@
 
 # Clean all object files
 clean:
-	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) $(FULL_LIB_PATH)/*.$(SO) src/$(PACKAGE_PATH)/NativeBlas.java generated-sources
+	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) $(FULL_LIB_PATH)/*.$(SO) $(SRC_JAVA)/$(PACKAGE_PATH)/NativeBlas.java $(SRC_C)/NativeBlas.c generated-sources
 
 # Full clean, including information extracted from the fortranwrappers.
 # You will need the original fortran sources in order to rebuild
@@ -110,7 +117,7 @@
 generated-sources: \
   scripts/fortranwrapper.rb scripts/fortran/types.rb \
   scripts/fortran/java.rb scripts/java-class.java scripts/java-impl.c \
-  src/org/jblas/util/ArchFlavor.java #src/org/jblas/NativeBlas.java 
+  $(SRC_JAVA)/org/jblas/util/ArchFlavor.java #src/org/jblas/NativeBlas.java
 	$(RUBY) scripts/fortranwrapper.rb --complexcc $(CCC) $(PACKAGE) NativeBlas \
 	$(BLAS)/[sdcz]copy.f \
 	$(BLAS)/[sdcz]swap.f \
@@ -132,24 +139,28 @@
 	$(LAPACK)/[sdcz]geev.f \
 	$(LAPACK)/[sd]getrf.f \
 	$(LAPACK)/[sd]potrf.f \
-	$(LAPACK)/[sdcz]gesvd.f
+	$(LAPACK)/[sdcz]gesvd.f \
+	$(LAPACK)/[sd]sygvd.f 
 	ant javah
 	touch $@
 
-native/NativeBlas.c: generated-sources
-
-native/NativeBlas.o: native/NativeBlas.c
-	$(CC) $(CFLAGS) $(INCDIRS) -c native/NativeBlas.c -o $@
-
-native/jblas_arch_flavor.o: generated-sources
-	$(CC) $(CFLAGS) $(INCDIRS) -c native/jblas_arch_flavor.c -o $@
+$(SRC_C)/NativeBlas.c: generated-sources
+
+$(TARGET_C):
+	mkdir $(TARGET_C)
+
+$(TARGET_C)/NativeBlas.o: $(SRC_C)/NativeBlas.c $(TARGET_C)
+	$(CC) $(CFLAGS) $(INCDIRS) -c $(SRC_C)/NativeBlas.c -o $@
+
+$(TARGET_C)/jblas_arch_flavor.o: generated-sources
+	$(CC) $(CFLAGS) $(INCDIRS) -c $(SRC_C)/jblas_arch_flavor.c -o $@
 
 # Move the compile library to the machine specific directory.
-$(FULL_LIB_PATH)/$(LIB)jblas.$(SO) : native/NativeBlas.$(SO)
+$(FULL_LIB_PATH)/$(LIB)jblas.$(SO) : $(TARGET_C)/NativeBlas.$(SO)
 	mkdir -p $(FULL_LIB_PATH)
 	mv "$<" "$@"
 
-$(LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO): native/jblas_arch_flavor.$(SO)
+$(LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO): $(SRC_C)/jblas_arch_flavor.$(SO)
 	mkdir -p $(LIB_PATH)
 	mv "$<" "$@"

=== debian/changelog ===
jblas (1.2.0-4) unstable; urgency=low

  [ tony mancill ]
  * Team upload.
  * Remove "+ssh" from Vcs-Svn URL (Closes: #669573)
  * Bump Standards-Version to 3.9.3 (no changes).

  [ Soeren Sonnenburg ]
  * Explicitly build depend on ruby 1.8 fixing the FTBS. (Closes: #676111)

 -- tony mancill <tmancill@debian.org>  Sat, 21 Apr 2012 20:45:10 -0700

jblas (1.2.0-3) unstable; urgency=low

  * Switch to default-jdk. (Closes: #643513)
  * Improve Description.
  * Remove Java runtime from Depends.
  * Add Suggests: jblas-doc.

 -- Torsten Werner <twerner@debian.org>  Tue, 04 Oct 2011 21:46:11 +0200

jblas (1.2.0-2) unstable; urgency=low

  * Upload to unstable.

 -- Soeren Sonnenburg <sonne@debian.org>  Mon, 14 Feb 2011 11:21:13 +0100

jblas (1.2.0-1) experimental; urgency=low

  * New upstream version.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 14 Jan 2011 13:51:48 +0100

=== debian/control ===
Source: jblas
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Soeren Sonnenburg <sonne@debian.org>,
 Torsten Werner <twerner@debian.org>
Build-Depends: cdbs, debhelper (>= 7), default-jdk, ant-optional, gfortran,
 libatlas-base-dev, ruby1.8
Standards-Version: 3.9.3
Section: science
Homepage: http://jblas.org
Vcs-Svn: svn://svn.debian.org/svn/pkg-java/trunk/jblas
Vcs-Browser: http://svn.debian.org/wsvn/pkg-java/trunk/jblas/

Package: jblas
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: jblas-doc
Description: fast linear algebra library for Java
 jblas is a fast linear algebra library for Java. jblas is essentially
 a light-weight wrapper around BLAS and LAPACK routines, the
 de-facto industry standard for matrix computations. It uses
 state-of-the-art implementations like ATLAS for all its computational
 routines, making it very fast. 
 .
 This package contains the binaries and examples.

Package: jblas-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: jblas
Section: doc
Description: fast linear algebra library for Java
 jblas is a fast linear algebra library for Java. jblas is essentially
 a light-weight wrapper around BLAS and LAPACK routines, the
 de-facto industry standard for matrix computations. It uses
 state-of-the-art implementations like ATLAS for all its computational
 routines, making it very fast. 
 .
 This package contains the documentation.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/class/ant.mk
 
-JAVA_HOME_DIRS       := /usr/lib/jvm/java-6-openjdk
+JAVA_HOME            := /usr/lib/jvm/default-java
 DEB_ANT_BUILDFILE    := build.xml
 DEB_ANT_BUILD_TARGET := minimal-jar javadoc
 DEB_ANT_CLEAN_TARGET := clean clean-jars
@@ -20,7 +20,7 @@
 
 install/jblas::
 	install -m755 -d debian/jblas/usr/lib/jni
-	install -m644 $(shell find ./native-libs/dynamic/Linux/ -name '*.so') debian/jblas/usr/lib/jni
+	install -m644 $(shell find ./src/main/resources/lib/dynamic -name '*.so') debian/jblas/usr/lib/jni
 	install -m644 -D jblas-minimal-$(DEB_UPSTREAM_VERSION).jar debian/jblas/usr/share/java/jblas-$(DEB_UPSTREAM_VERSION).jar
 	dh_link -pjblas /usr/share/java/jblas-$(DEB_UPSTREAM_VERSION).jar /usr/share/java/jblas.jar

## jblas 1.2.3

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ## --- END LICENSE BLOCK ---
 
-VERSION=1.2.0
+VERSION=1.2.1
 
 ######################################################################
 #
@@ -140,7 +140,10 @@
 	$(LAPACK)/[sd]getrf.f \
 	$(LAPACK)/[sd]potrf.f \
 	$(LAPACK)/[sdcz]gesvd.f \
-	$(LAPACK)/[sd]sygvd.f 
+	$(LAPACK)/[sd]sygvd.f \
+	$(LAPACK)/[sd]gelsd.f \
+	$(LAPACK)/ilaenv.f \
+	$(LAPACK)/[sd]geqrf.f $(LAPACK)/[sd]ormqr.f
 	ant javah
 	touch $@

=== debian/changelog ===
jblas (1.2.3-6) unstable; urgency=medium

  * Declare a Build-Conflicts with locales-all.  See #788352.
    (Closes: #788353)

 -- tony mancill <tmancill@debian.org>  Wed, 10 Jun 2015 22:24:43 -0700

jblas (1.2.3-5) unstable; urgency=medium

  * Tweak debian/rules to address FTBFS (tests) on ppc64el.
    - Thanks to Fernando Seiti Furusato. (Closes: #770203)

 -- tony mancill <tmancill@debian.org>  Wed, 19 Nov 2014 22:58:37 -0800

jblas (1.2.3-4) unstable; urgency=medium

  * Tweak debian/rules for tests on arm64 to resolve FTBFS on that arch.
    (Thanks to Wookey for providing a porting box).
  * Bump Standards-Version to 3.9.6 (no changes).
  * Add myself to Uploaders.

 -- tony mancill <tmancill@debian.org>  Thu, 16 Oct 2014 21:35:50 -0700

jblas (1.2.3-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Tweak debian/rules for tests on powerpc.
  * Remove ./target/ in clean target of debian/rules.
  
 -- tony mancill <tmancill@debian.org>  Thu, 23 Jan 2014 20:37:23 -0800

jblas (1.2.3-2) experimental; urgency=medium

  * Team upload.
  * Set LD_LIBRARY_PATH before running unit tests to address FTBFS
    on architectures other than i386 and amd64.

 -- tony mancill <tmancill@debian.org>  Sun, 12 Jan 2014 09:59:54 -0800

jblas (1.2.3-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - Remove build-with-ruby19.patch
  * Set architecture to linux-any.
  * Upload to experimental.

 -- tony mancill <tmancill@debian.org>  Thu, 09 Jan 2014 20:47:40 -0800

jblas (1.2.0-6) unstable; urgency=medium

  * Team upload.
  * Restore lintian overrides that Soeren had added to SVN repo.
  * Relocate package repository to git; update Vcs URLs.
  * Constrict architectures to i386 and amd64.  (Closes: #734279)
    - This should be temporary; until jblas functions on other arches.

 -- tony mancill <tmancill@debian.org>  Thu, 09 Jan 2014 06:40:57 -0800

jblas (1.2.0-5) unstable; urgency=medium

  * Team upload.
  * Add build-with-ruby19.patch (Closes: #733773) 
    - package now has build-dep on locales
  * Enable tests.
    - package now has build-dep on junit4
  * Update Vcs URLs to be canonical.
  * Depend on DH 9.
  * Bump Standards-Version to 3.9.5 (no changes).

 -- tony mancill <tmancill@debian.org>  Sat, 04 Jan 2014 12:29:52 -0800

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,26 @@
 Priority: optional
 Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
 Uploaders: Soeren Sonnenburg <sonne@debian.org>,
- Torsten Werner <twerner@debian.org>
-Build-Depends: cdbs, debhelper (>= 7), default-jdk, ant-optional, gfortran,
- libatlas-base-dev, ruby1.8
-Standards-Version: 3.9.3
+ Torsten Werner <twerner@debian.org>,
+ tony mancill <tmancill@debian.org>
+Build-Depends: cdbs,
+ debhelper (>= 9),
+ default-jdk,
+ ant-optional,
+ gfortran,
+ libatlas-base-dev,
+ ruby,
+ locales,
+ junit4
+Build-Conflicts: locales-all
+Standards-Version: 3.9.6
 Section: science
 Homepage: http://jblas.org
-Vcs-Svn: svn://svn.debian.org/svn/pkg-java/trunk/jblas
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-java/trunk/jblas/
+Vcs-Git: git://anonscm.debian.org/pkg-java/jblas.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-java/jblas.git
 
 Package: jblas
-Architecture: any
+Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: jblas-doc
 Description: fast linear algebra library for Java

=== debian/rules ===
--- 
+++ 
@@ -7,22 +7,53 @@
 DEB_ANT_BUILDFILE    := build.xml
 DEB_ANT_BUILD_TARGET := minimal-jar javadoc
 DEB_ANT_CLEAN_TARGET := clean clean-jars
-DEB_JARS := ant-nodeps.jar
+DEB_ANT_CHECK_TARGET := test
+DEB_JARS := ant-nodeps.jar junit4.jar ant-junit4.jar ant-junit.jar
+
+# tell CDBS to be more verbose
+DEB_VERBOSE_ALL := true
+
+# override DEB_ANT_INVOKE
+#DEB_ANT_INVOKE := export LOCPATH=$(CURDIR)/debian/tmp/locale/ && export LC_ALL=en_US.UTF-8 && $(DEB_ANT_INVOKE)
 
 clean::
 	make clean || true
+	rm -rf target
 
 debian/stamp-ant-build: debian/stamp-jblas-build
 debian/stamp-jblas-build:
-	./configure --libpath=/usr/lib:/usr/lib/atlas
-	make
+	mkdir -p debian/tmp/locale/
+	localedef -f UTF-8 -i en_US ./debian/tmp/locale/en_US.UTF-8/
+	export LOCPATH=$(CURDIR)/debian/tmp/locale/ && \
+		export LC_ALL=en_US.UTF-8 && \
+		./configure --libpath=/usr/lib:/usr/lib/atlas
+	export LOCPATH=$(CURDIR)/debian/tmp/locale/ && \
+		export LC_ALL=en_US.UTF-8 && \
+		make
+	touch $@
+
+debian/stamp-ant-check:
+	# the tests need to be able to find the JNI libs
+ifeq ($(DEB_BUILD_ARCH_CPU),powerpc)
+	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/ppc \
+               && $(DEB_ANT_INVOKE) $(DEB_ANT_CHECK_TARGET)
+else ifeq ($(DEB_BUILD_ARCH_CPU),arm64)
+	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/aarch64 \
+               && $(DEB_ANT_INVOKE) $(DEB_ANT_CHECK_TARGET)
+else ifeq ($(DEB_BUILD_ARCH_CPU),ppc64el)
+	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/ppc64 \
+               && $(DEB_ANT_INVOKE) $(DEB_ANT_CHECK_TARGET)
+else
+	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/$(DEB_BUILD_ARCH_CPU) \
+		&& $(DEB_ANT_INVOKE) $(DEB_ANT_CHECK_TARGET)
+endif
 	touch $@
 
 install/jblas::
 	install -m755 -d debian/jblas/usr/lib/jni
 	install -m644 $(shell find ./src/main/resources/lib/dynamic -name '*.so') debian/jblas/usr/lib/jni
-	install -m644 -D jblas-minimal-$(DEB_UPSTREAM_VERSION).jar debian/jblas/usr/share/java/jblas-$(DEB_UPSTREAM_VERSION).jar
-	dh_link -pjblas /usr/share/java/jblas-$(DEB_UPSTREAM_VERSION).jar /usr/share/java/jblas.jar
+	install -m644 -D jblas-minimal-$(DEB_UPSTREAM_VERSION)-SNAPSHOT.jar debian/jblas/usr/share/java/jblas-$(DEB_UPSTREAM_VERSION)-SNAPSHOT.jar
+	dh_link -pjblas /usr/share/java/jblas-$(DEB_UPSTREAM_VERSION)-SNAPSHOT.jar /usr/share/java/jblas.jar
 
 install/jblas-doc:: debian/stamp-install-jblas-doc
 debian/stamp-install-jblas-doc:

=== debian/watch ===
version=3
http://github.com/mikiobraun/jblas/downloads .*/mikiobraun/jblas/tarball/jblas-(.*) \
 debian debian/orig-tar.sh

## jblas 1.2.4

=== Makefile ===
--- 
+++ 
@@ -98,7 +98,10 @@
 
 # Clean all object files
 clean:
-	rm -f native/*.o native/*.$(SO) $(LIB_PATH)/*.$(SO) $(FULL_LIB_PATH)/*.$(SO) $(SRC_JAVA)/$(PACKAGE_PATH)/NativeBlas.java $(SRC_C)/NativeBlas.c generated-sources
+	rm -f native/*.o native/*.$(SO) \
+	 $(LIB_PATH)/$(LIB)jblas.$(SO) $(LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO) \
+	 $(FULL_LIB_PATH)/$(LIB)jblas.$(SO) $(FULL_LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO) \
+	 $(SRC_JAVA)/$(PACKAGE_PATH)/NativeBlas.java $(SRC_C)/NativeBlas.c generated-sources
 
 # Full clean, including information extracted from the fortranwrappers.
 # You will need the original fortran sources in order to rebuild
@@ -143,28 +146,29 @@
 	$(LAPACK)/[sd]sygvd.f \
 	$(LAPACK)/[sd]gelsd.f \
 	$(LAPACK)/ilaenv.f \
-	$(LAPACK)/[sd]geqrf.f $(LAPACK)/[sd]ormqr.f
+	$(LAPACK)/[sd]geqrf.f $(LAPACK)/[sd]ormqr.f \
+	$(LAPACK)/[sd]orgqr.f \
+	$(LAPACK)/[sd]sygvx.f
 	ant javah
 	touch $@
 
 $(SRC_C)/NativeBlas.c: generated-sources
 
-$(TARGET_C):
-	mkdir $(TARGET_C)
-
-$(TARGET_C)/NativeBlas.o: $(SRC_C)/NativeBlas.c $(TARGET_C)
+$(TARGET_C)/NativeBlas.o: $(SRC_C)/NativeBlas.c
+	@mkdir -p "$(dir $@)"
 	$(CC) $(CFLAGS) $(INCDIRS) -c $(SRC_C)/NativeBlas.c -o $@
 
 $(TARGET_C)/jblas_arch_flavor.o: generated-sources
+	@mkdir -p "$(dir $@)"
 	$(CC) $(CFLAGS) $(INCDIRS) -c $(SRC_C)/jblas_arch_flavor.c -o $@
 
 # Move the compile library to the machine specific directory.
 $(FULL_LIB_PATH)/$(LIB)jblas.$(SO) : $(TARGET_C)/NativeBlas.$(SO)
-	mkdir -p $(FULL_LIB_PATH)
+	@mkdir -p "$(dir $@)"
 	mv "$<" "$@"
 
 $(LIB_PATH)/$(LIB)jblas_arch_flavor.$(SO): $(SRC_C)/jblas_arch_flavor.$(SO)
-	mkdir -p $(LIB_PATH)
+	@mkdir -p "$(dir $@)"
 	mv "$<" "$@"
 
 ######################################################################

=== debian/changelog ===
jblas (1.2.4-3) unstable; urgency=medium

  * Avoid B-D on specific BLAS/LAPACK implementation (Closes: #976264)
    Thank you to Mo Zhou for the patch.  Also see #943712.
  * Set Rules-Requires-Root: no in debian/control
  * Use debhelper-compat 13
  * Bump Standards-Version to 4.5.1
  * Update Vcs URLs to point to Salsa
  * Check DEB_BUILD_OPTIONS before running tests
  * Update debian/watch URL on Github
  * No longer name the versioned JAR as a SNAPSHOT
  * Correct documentation path in doc-base

 -- tony mancill <tmancill@debian.org>  Sat, 12 Dec 2020 21:19:39 -0800

jblas (1.2.4-2) unstable; urgency=medium

  * Team upload.
  * Fixed the build failure with Java 10 (Closes: #898227)
  * Removed Soeren Sonnenburg from the uploaders (Closes: #881836)
  * Removed the build conflict with locales-all
  * Merged and simplified the Java 9 patches
  * Standards-Version updated to 4.1.4
  * Switch to debhelper level 11

 -- Emmanuel Bourg <ebourg@apache.org>  Wed, 09 May 2018 00:30:33 +0200

jblas (1.2.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.2.4.
  * Fix FTBFS with Java 9. Thanks to Chris West for the report and patches.
    (Closes: #873212)
  * Ensure that jblas can be built twice in a row. Thanks to Zbigniew
    Jedrzejewski-Szmek for the report. (Closes: #698176)
  * Switch to compat level 10.
  * Drop orig-tar.sh script.
  * Improve watch file and detect new Github releases.
  * Improve get-orig-source target.
  * Declare compliance with Debian Policy 4.1.1.
  * Use canonical Vcs address.
  * Migrate from CDBS to DH sequencer and fix FTBFS with multiarch
    libatlas-base-dev. Thanks to Adrian Bunk for the report. (Closes: #877225)
  * wrap-and-sort -sa.
  * Add version-property.patch and fix the wrong version.
  * Install javadoc with jblas-doc.docs.
  * Remove jblas.lintian-overrides
  * Add javadoc.patch and ignore errors when building the documentation. This
    will create all necessary files including the missing index.html file.
  * Build with debug symbols.

 -- Markus Koschany <apo@debian.org>  Mon, 23 Oct 2017 21:25:10 +0200

=== debian/control ===
Source: jblas
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders:
 Torsten Werner <twerner@debian.org>,
 tony mancill <tmancill@debian.org>
Build-Depends:
 ant-optional,
 debhelper-compat (= 13),
 default-jdk,
 gfortran,
 junit4,
 libblas-dev,
 liblapack-dev,
 locales,
 ruby
Standards-Version: 4.5.1
Section: science
Homepage: http://jblas.org
Vcs-Git: https://salsa.debian.org/java-team/jblas.git
Vcs-Browser: https://salsa.debian.org/java-team/jblas
Rules-Requires-Root: no

Package: jblas
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 jblas-doc
Description: fast linear algebra library for Java
 jblas is a fast linear algebra library for Java. jblas is essentially
 a light-weight wrapper around BLAS and LAPACK routines, the
 de-facto industry standard for matrix computations. It uses
 state-of-the-art implementations like ATLAS for all its computational
 routines, making it very fast.
 .
 This package contains the binaries and examples.

Package: jblas-doc
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 jblas
Section: doc
Description: fast linear algebra library for Java --documentation
 jblas is a fast linear algebra library for Java. jblas is essentially
 a light-weight wrapper around BLAS and LAPACK routines, the
 de-facto industry standard for matrix computations. It uses
 state-of-the-art implementations like ATLAS for all its computational
 routines, making it very fast.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
export JAVA_HOME := /usr/lib/jvm/default-java
export CLASSPATH := /usr/share/java/ant-nodeps.jar:/usr/share/java/junit4.jar:/usr/share/java/ant-junit4.jar:/usr/share/java/ant-junit.jar

%:
	dh $@ --buildsystem=ant

override_dh_auto_build:
	# Build the native libraries first
	mkdir -p debian/tmp/locale/
	localedef -f UTF-8 -i en_US ./debian/tmp/locale/en_US.UTF-8/
	export LOCPATH=$(CURDIR)/debian/tmp/locale/ && \
		export LC_ALL=en_US.UTF-8 && \
		./configure --libpath=/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/blas:/usr/lib/$(DEB_HOST_MULTIARCH)/lapack --lapack-build --built-type=lapack
	export LOCPATH=$(CURDIR)/debian/tmp/locale/ && \
		export LC_ALL=en_US.UTF-8 && \
		$(MAKE)
	# Build the jar files
	dh_auto_build -- minimal-jar javadoc

override_dh_auto_clean:
	dh_auto_clean -- clean clean-jars

override_dh_install:
	install -m755 -d debian/jblas/usr/lib/jni
	install -m644 $(shell find ./src/main/resources/lib/dynamic -name '*.so') debian/jblas/usr/lib/jni
	install -m644 -D jblas-minimal-$(DEB_VERSION_UPSTREAM).jar \
		debian/jblas/usr/share/java/jblas-$(DEB_VERSION_UPSTREAM).jar

override_dh_link:
	dh_link
	dh_link -pjblas /usr/share/java/jblas-$(DEB_VERSION_UPSTREAM).jar /usr/share/java/jblas.jar

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# the tests need to be able to find the JNI libs
ifeq ($(DEB_BUILD_ARCH),powerpc)
	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/ppc
else ifeq ($(DEB_BUILD_ARCH),arm64)
	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/aarch64
else ifeq ($(DEB_BUILD_ARCH),ppc64el)
	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/ppc64
else
	export LD_LIBRARY_PATH=$(CURDIR)/src/main/resources/lib/dynamic/Linux/$(DEB_BUILD_ARCH)
endif
	dh_auto_test
endif

=== debian/watch ===
version=4
https://github.com/jblas-project/jblas/tags .*/jblas-(\d\S+)\.tar\.gz

## jblas 1.2.5+dfsg

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 #       disclaimer in the documentation and/or other materials provided
 #       with the distribution.
 # 
-#     * Neither the name of the Technische Universität Berlin nor the
+#     * Neither the name of the Technische Universitaet Berlin nor the
 #       names of its contributors may be used to endorse or promote
 #       products derived from this software without specific prior
 #       written permission.
@@ -32,7 +32,7 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ## --- END LICENSE BLOCK ---
 
-VERSION=1.2.1
+VERSION=1.2.5
 
 ######################################################################
 #
@@ -221,3 +221,67 @@
 		-Dos_arch=$$(basename $$os_arch); \
 	  done; \
 	done
+
+################################################################################
+#
+# Docker development
+#
+
+#------------------------------------------------
+# x86_64 / amd64
+#
+# Compile with 18.04, 20.04 for testing
+
+
+#
+# Ubuntu 18.04
+#
+shell-ubuntu1804:
+	docker build -f docker/dev-ubuntu1804.Dockerfile -t jblas/dev-ubuntu1804 .
+	docker run -it --rm -v $(PWD):/home/dev jblas/dev-ubuntu1804 /bin/bash
+
+test-ubuntu1804:
+	docker build -f docker/test-ubuntu1804.Dockerfile -t jblas/test-ubuntu1804 .
+	docker run --rm jblas/test-ubuntu1804 /bin/bash
+
+
+#
+# Ubuntu 20.04: Does not work on Ubuntu 18.04 if you use these!
+#
+shell-ubuntu2004:
+	docker build -f docker/dev-ubuntu2004.Dockerfile -t jblas/dev-ubuntu2004 .
+	docker run -it --rm -v $(PWD):/home/dev jblas/dev-ubuntu2004 /bin/bash
+
+test-ubuntu2004:
+	docker build -f docker/test-ubuntu2004.Dockerfile -t jblas/test-ubuntu2004 .
+	docker run --rm jblas/test-ubuntu2004 /bin/bash
+
+
+#----------------------------------------------------------
+# aarch64 / arm64
+#
+# Compile with 20.04, use 18.04 for testing (other way round!)
+
+shell-ubuntu1804-arm64:
+	docker build -f docker/dev-ubuntu1804-arm64.Dockerfile -t jblas/dev-ubuntu1804-arm64 .
+	docker run -it --rm -v $(PWD):/home/dev jblas/dev-ubuntu1804-arm64 /bin/bash
+
+test-ubuntu1804-arm64:
+	docker build -f docker/test-ubuntu1804-arm64.Dockerfile -t jblas/test-ubuntu1804-arm64 .
+	docker run --rm jblas/test-ubuntu1804-arm64 /bin/bash
+
+shell-ubuntu2004-arm64:
+	docker build -f docker/dev-ubuntu2004-arm64.Dockerfile -t jblas/dev-ubuntu2004-arm64 .
+	docker run -it --rm -v $(PWD):/home/dev jblas/dev-ubuntu2004-arm64 /bin/bash
+
+test-ubuntu2004-arm64:
+	docker build -f docker/test-ubuntu2004-arm64.Dockerfile -t jblas/test-ubuntu2004-arm64 .
+	docker run --rm jblas/test-ubuntu2004-arm64 /bin/bash
+
+#
+# meta build target.
+#
+build:
+	./configure
+	make clean all
+	mvn package -Dmaven.test.skip=True

=== debian/changelog ===
jblas (1.2.5+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.5
  * Reformat debian/copyright and add Files-Excluded for DFSG repack
  * Update debian/watch for dfsg suffix
  * Add patch to correct typo in upstream configure for --dynamic-libs
  * Enable dynamic-libs for Debian build (this was the default in 1.2.4)
  * Install JNI library beneath multiarch tuple
  * Drop jblas-doc (javadoc) package
  * Bump Standards-Version to 4.6.2
  * Update debian/rules clean target (Closes: #1049092)

 -- tony mancill <tmancill@debian.org>  Sun, 15 Oct 2023 21:05:59 -0700

=== debian/control ===
Source: jblas
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders:
 Torsten Werner <twerner@debian.org>,
 tony mancill <tmancill@debian.org>
Build-Depends:
 ant-optional,
 debhelper-compat (= 13),
 default-jdk,
 gfortran,
 junit4,
 libblas-dev,
 liblapack-dev,
 locales,
 ruby
Standards-Version: 4.6.2
Section: science
Homepage: https://jblas.org
Vcs-Git: https://salsa.debian.org/java-team/jblas.git
Vcs-Browser: https://salsa.debian.org/java-team/jblas
Rules-Requires-Root: no

Package: jblas
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: fast linear algebra library for Java
 jblas is a fast linear algebra library for Java. jblas is essentially
 a light-weight wrapper around BLAS and LAPACK routines, the
 de-facto industry standard for matrix computations. It uses
 state-of-the-art implementations like ATLAS for all its computational
 routines, making it very fast.
 .
 This package contains the binaries and examples.

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+VERSION_DFSG := $(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+dfsg//')
 export JAVA_HOME := /usr/lib/jvm/default-java
 export CLASSPATH := /usr/share/java/ant-nodeps.jar:/usr/share/java/junit4.jar:/usr/share/java/ant-junit4.jar:/usr/share/java/ant-junit.jar
 
@@ -16,25 +17,41 @@
 	localedef -f UTF-8 -i en_US ./debian/tmp/locale/en_US.UTF-8/
 	export LOCPATH=$(CURDIR)/debian/tmp/locale/ && \
 		export LC_ALL=en_US.UTF-8 && \
-		./configure --libpath=/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/blas:/usr/lib/$(DEB_HOST_MULTIARCH)/lapack --lapack-build --built-type=lapack
+		./configure --libpath=/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/blas:/usr/lib/$(DEB_HOST_MULTIARCH)/lapack --lapack-build --build-type=lapack --dynamic-libs
 	export LOCPATH=$(CURDIR)/debian/tmp/locale/ && \
 		export LC_ALL=en_US.UTF-8 && \
 		$(MAKE)
 	# Build the jar files
-	dh_auto_build -- minimal-jar javadoc
+	dh_auto_build -- minimal-jar
 
 override_dh_auto_clean:
+	for x in config/PrintProperty.class \
+		config/arch_flavor \
+		generated-sources \
+		src/main/resources/lib/dynamic/Linux/amd64/libjblas_arch_flavor.so \
+		src/main/resources/lib/dynamic/Linux/amd64/sse3/libjblas.so \
+		target/c/NativeBlas.o \
+		configure.log \
+		configure.options \
+		configure.out \
+		configure.xml \
+		src/main/java/org/jblas/ComplexDoubleMatrix.java.rjpp \
+		src/main/java/org/jblas/DoubleMatrix.java.rjpp \
+		src/main/java/org/jblas/MatrixFunctions.java.rjpp \
+		src/test/java/org/jblas/TestDoubleMatrix.java.rjpp ; do \
+	   rm -fv $$x ; done
 	dh_auto_clean -- clean clean-jars
 
 override_dh_install:
-	install -m755 -d debian/jblas/usr/lib/jni
-	install -m644 $(shell find ./src/main/resources/lib/dynamic -name '*.so') debian/jblas/usr/lib/jni
-	install -m644 -D jblas-minimal-$(DEB_VERSION_UPSTREAM).jar \
-		debian/jblas/usr/share/java/jblas-$(DEB_VERSION_UPSTREAM).jar
+	install -m755 -d debian/jblas/usr/lib/$(DEB_HOST_MULTIARCH)/jni
+	install -m644 $(shell find ./src/main/resources/lib/dynamic -name '*.so') \
+		debian/jblas/usr/lib/$(DEB_HOST_MULTIARCH)/jni
+	install -m644 -D jblas-minimal-$(VERSION_DFSG).jar \
+		debian/jblas/usr/share/java/jblas-$(VERSION_DFSG).jar
 
 override_dh_link:
 	dh_link
-	dh_link -pjblas /usr/share/java/jblas-$(DEB_VERSION_UPSTREAM).jar /usr/share/java/jblas.jar
+	dh_link -pjblas /usr/share/java/jblas-$(VERSION_DFSG).jar /usr/share/java/jblas.jar
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

=== debian/watch ===
version=4
opts="repack,repacksuffix=+dfsg,compression=xz,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
https://github.com/jblas-project/jblas/tags .*/jblas-(\d\S+)\.tar\.gz
